/*
Copyright (C) 2006 Parallel Realities

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

class LocaleManager {

	private:

		static LocaleManager instance;

		String localePath;
		String localeKey;

		char language[3];

		Properties localeData;

		// used for reporting errors, etc. This is always needed.
		Properties systemLocaleData;

	LocaleManager();
	~LocaleManager();

	public:
		
		Properties localeIndex;

	static LocaleManager *getInstance();
	
	void clear();
	void destroy();

	void setLocalePath(char *localePath);

	void setLanguage(char *language);
	char *getLanguage();

	void setLocaleData(Properties *localeData);
	void appendLocaleData(Properties *localeData);
	void setSystemLocaleData(Properties *localeData);

	char *translate(char *key);
	char *translateSystemMessage(char *key);
	
	void removeLocaleData(char *key);

	void listLocaleData();

};
